{******************Autor - Cdigo fonte: Fabrcio Hissao Kawata****************}

unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, Grids, DBGrids, ComObj, ExcelXP, OleServer, DBClient;

type
  TfrmMain = class(TForm)
    dbgGrid: TDBGrid;
    gbxExportar: TGroupBox;
    dsrProdutos: TDataSource;
    btnExpOLE: TButton;
    btnExpServers: TButton;
    btnExpMacro: TButton;
    gbxImportar: TGroupBox;
    btnImpServers: TButton;
    ExcelApplication1: TExcelApplication;
    ExcelWorksheet1: TExcelWorksheet;
    OpenDialog1: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure btnExpOLEClick(Sender: TObject);
    procedure btnExpServersClick(Sender: TObject);
    procedure btnExpMacroClick(Sender: TObject);
    procedure btnImpServersClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses untDM;

{$R *.dfm}

procedure TfrmMain.FormShow(Sender: TObject);
begin
  //garante que o DataSet inicie aberto
  dsrProdutos.DataSet.Open;
end;

procedure TfrmMain.btnExpOLEClick(Sender: TObject);
var
  excel: OleVariant;
  linha, i, coluna: Integer;
begin
  try
    //Controles visuais do formulrio
    Screen.Cursor:= crHourGlass;
    dsrProdutos.DataSet.DisableControls;

    //Instancia-se um objeto OLE relativo ao Excel
    excel:= CreateOleObject('Excel.Application');
    excel.Workbooks.add(1);
    
    try
      //Escreve o cabealho das colunas
      coluna:= 1;
      for i:= 0 to Pred(dsrProdutos.DataSet.Fields.Count) do
      begin
        excel.cells[1, coluna]:= dsrProdutos.DataSet.Fields[i].DisplayLabel;
        excel.cells[1, coluna].Font.Bold:= True;
        Inc(coluna);
      end;

      //Escreve os dados
      linha:= 2;
      dsrProdutos.DataSet.First;
      while not dsrProdutos.DataSet.Eof do
      begin
        coluna:= 1;
        for i:= 0 to Pred(dsrProdutos.DataSet.Fields.Count) do
        begin
          //De acordo com o tipo do campo, formata-se a clula do Excel
          case dsrProdutos.DataSet.Fields[i].DataType of
            ftDate, ftDateTime:
              begin
                excel.cells[linha,coluna].NumberFormat:= 'dd/mm/aaaa';
                excel.cells[linha,coluna]:= dsrProdutos.DataSet.Fields[i].AsDateTime;
              end;
            ftString, ftFixedChar:
              begin
                excel.cells[linha,coluna].NumberFormat:= '@';
                excel.cells[linha,coluna]:= dsrProdutos.DataSet.Fields[i].AsString;
              end;
            ftFloat, ftFMTBcd, ftCurrency:
              begin
                excel.cells[linha,coluna].NumberFormat:= '#.##0,00';
                excel.cells[linha,coluna]:= dsrProdutos.DataSet.Fields[i].AsFloat;
              end;
          else
            excel.cells[linha,coluna]:= dsrProdutos.DataSet.Fields[i].Value;
          end;
          
          Inc(coluna);
        end;
        dsrProdutos.DataSet.Next;
        Inc(linha);
      end;

      //Configura as linhas e colunas para AutoFit
      excel.columns.AutoFit;
      excel.Rows.AutoFit;

      //Traz para a tela a planilha
      excel.Visible:= True;
    except
      on e: Exception do
      begin
        Application.MessageBox(PAnsiChar('Erro ao gerar a planilha: ' + e.Message),
          'Erro', MB_ICONERROR);
      end;
    end;
  finally
    dsrProdutos.DataSet.EnableControls;
    Screen.Cursor:= crDefault;
  end;
end;

procedure TfrmMain.btnExpServersClick(Sender: TObject);
var
  lcid, Linha: Integer;
  wkbk: _Workbook;
begin
  try
    try
      //Atribuio das variveis
      lcid:= GetUserDefaultLCID;
      ExcelApplication1.DisplayAlerts[lcid]:= False;
      wkbk:= ExcelApplication1.Workbooks.Add(EmptyParam, lcid);
      ExcelWorksheet1.ConnectTo(wkbk.Worksheets[1] as _Worksheet);
      ExcelWorksheet1.Activate(LCID);
      ExcelApplication1.ScreenUpdating[lcid]:= True;
      
      {---------------------------------CABEALHO------------------------------}
      ExcelWorksheet1.Range['A1','A1'].Value2:= dsrProdutos.DataSet.Fields[0].DisplayLabel;
      ExcelWorksheet1.Range['B1','B1'].Value2:= dsrProdutos.DataSet.Fields[1].DisplayLabel;
      ExcelWorksheet1.Range['C1','C1'].Value2:= dsrProdutos.DataSet.Fields[2].DisplayLabel;
      ExcelWorksheet1.Range['D1','D1'].Value2:= dsrProdutos.DataSet.Fields[3].DisplayLabel;
      ExcelWorksheet1.Range['E1','E1'].Value2:= dsrProdutos.DataSet.Fields[4].DisplayLabel;
      ExcelWorksheet1.Range['F1','F1'].Value2:= dsrProdutos.DataSet.Fields[4].DisplayLabel;
      ExcelWorksheet1.Range['G1','G1'].Value2:= dsrProdutos.DataSet.Fields[4].DisplayLabel;

      ExcelWorksheet1.Range['A1','G1'].Font.Bold:= True;
      
      {---------------------------------REGISTROS------------------------------}
      Linha:= 2;
      dsrProdutos.DataSet.First;
      while not dsrProdutos.DataSet.Eof do
      begin
        ExcelWorksheet1.Range['A' + IntToStr(Linha),'A' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[0].AsString;

        ExcelWorksheet1.Range['B' + IntToStr(Linha),'B' + IntToStr(Linha)].NumberFormat:= 'dd/mm/aaaa';
        ExcelWorksheet1.Range['B' + IntToStr(Linha),'B' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[1].AsDateTime;

        ExcelWorksheet1.Range['C' + IntToStr(Linha),'C' + IntToStr(Linha)].NumberFormat:= '@';
        ExcelWorksheet1.Range['C' + IntToStr(Linha),'C' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[2].AsString;

        ExcelWorksheet1.Range['D' + IntToStr(Linha),'D' + IntToStr(Linha)].NumberFormat:= '@';
        ExcelWorksheet1.Range['D' + IntToStr(Linha),'D' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[3].AsString;

        ExcelWorksheet1.Range['E' + IntToStr(Linha),'E' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[4].Value;

        ExcelWorksheet1.Range['F' + IntToStr(Linha),'F' + IntToStr(Linha)].NumberFormat:= '#.##0,00';
        ExcelWorksheet1.Range['F' + IntToStr(Linha),'F' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[5].AsFloat;

        ExcelWorksheet1.Range['G' + IntToStr(Linha),'G' + IntToStr(Linha)].Value2:=
          dsrProdutos.DataSet.Fields[6].Value;

        Inc(Linha);
        dsrProdutos.DataSet.Next;
      end;

      //Configura as linhas e colunas para AutoFit
      ExcelApplication1.Columns.AutoFit;

      //Traz para a tela a planilha
      ExcelApplication1.Visible[lcid]:= True;
    except
      on e: Exception do
      begin
        Application.MessageBox(PAnsiChar('Erro ao gerar a planilha: ' + e.Message),
          'Erro', MB_ICONERROR);
      end;
    end;
  finally
    ExcelApplication1.Disconnect;
  end;
end;

procedure TfrmMain.btnExpMacroClick(Sender: TObject);
var
  excel: OleVariant;
begin
  try
    try
      //Controles visuais do formulrio
      Screen.Cursor:= crHourGlass;
      dsrProdutos.DataSet.DisableControls;

      //Instancia-se um objeto OLE relativo ao Excel
      excel:= CreateOleObject('Excel.Application');
      excel.Workbooks.add(1);

      //o arquivo .txt precisa ser Unicode
      //macro para gerar a planilha com base num arquivo txt pr-definido
      excel.Workbooks.OpenText(
        filename:= ExtractFilePath(Application.ExeName) + 'Excel.txt',
        Origin:= xlWindows,
        StartRow:= 1,
        ConsecutiveDelimiter:= False,
        DataType:= xlDelimited,
        TextQualifier:= xlTextQualifierDoubleQuote,
        Tab:= False,
        Comma:= False,
        Semicolon:= True,
        Space:= False,
        Other:= True,
        OtherChar:= '|');

      //Configura as linhas e colunas para AutoFit
      excel.columns.AutoFit;
      excel.Rows.AutoFit;

      //Traz para a tela a planilha
      excel.Visible:= True;
    except
      on e: Exception do
      begin
        Application.MessageBox(PAnsiChar('Erro ao gerar a planilha: ' + e.Message),
          'Erro', MB_ICONERROR);
      end;
    end;
  finally
    dsrProdutos.DataSet.EnableControls;
    Screen.Cursor:= crDefault;
  end;
end;

procedure TfrmMain.btnImpServersClick(Sender: TObject);
var
  lcid, linha: Integer;
  wkbk: _Workbook;
begin
  try
    try
      OpenDialog1.Execute;
      lcid:= GetUserDefaultLCID;
      ExcelApplication1.Visible[lcid]:= True;
      ExcelApplication1.DisplayAlerts[lcid]:= False;
      wkBk:= ExcelApplication1.Workbooks.Open(OpenDialog1.FileName,EmptyParam,EmptyParam,
        EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,
        EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,LCID);
      ExcelWorksheet1.ConnectTo(WkBk.Worksheets[1] as _Worksheet);
      ExcelWorksheet1.Activate(LCID);
      ExcelApplication1.ScreenUpdating[lcid]:= True;

      linha:= 2;

      //percorre a planilha e, a cada iterao,  inserido um registro na tabela
      while Trim(ExcelWorksheet1.Range['D'+IntToStr(linha), 'D'+IntToStr(linha)].Text) <> EmptyStr do
      begin
        dsrProdutos.DataSet.Close;
        dsrProdutos.DataSet.Open;
        dsrProdutos.DataSet.Append;
        dsrProdutos.DataSet.FieldByName('DATA_CADASTRO').AsDateTime:= Now;
        dsrProdutos.DataSet.FieldByName('CODIGO').AsString:= Trim(ExcelWorksheet1.Range['C'+IntToStr(linha), 'C'+IntToStr(linha)].Text);
        dsrProdutos.DataSet.FieldByName('NOME').AsString:= Trim(ExcelWorksheet1.Range['D'+IntToStr(linha), 'D'+IntToStr(linha)].Text);
        dsrProdutos.DataSet.FieldByName('ESTOQUE').AsInteger:= StrToInt(ExcelWorksheet1.Range['E'+IntToStr(linha), 'E'+IntToStr(linha)].Text);
        dsrProdutos.DataSet.FieldByName('VALOR').AsFloat:=
          StrToFloat(StringReplace(Trim(ExcelWorksheet1.Range['F' + IntToStr(linha), 'F' + IntToStr(linha)].Text), '.', '', [rfReplaceAll]));
        dsrProdutos.DataSet.FieldByName('DESCRICAO').AsString:= ExcelWorksheet1.Range['G'+IntToStr(linha), 'G'+IntToStr(linha)].Text;
        dsrProdutos.DataSet.Post;

        //Marca como importado
        ExcelWorksheet1.Range['I'+IntToStr(linha), 'I'+IntToStr(linha)].Value2:= 'X';
        Inc(linha);
      end;

        Application.MessageBox('Importao concluda com sucesso', 'Ateno', MB_ICONINFORMATION);
    except
      on e:exception do
      begin
        Application.MessageBox(PAnsiChar('Erro ao importar planilha: ' + e.Message),
          'Erro', MB_ICONERROR);
      end;
    end;
  finally
    ExcelApplication1.Disconnect;
  end;
end;

end.
