unit BooleanPropertyEditor;

interface

uses
  Windows, Classes, Graphics, Types, ExtCtrls, DesignEditors,
  VCLEditors, TypInfo, DesignIntf;

type
  TBooleanPropertyImage = class(TEnumProperty,ICustomPropertyListDrawing,ICustomPropertyDrawing)
  procedure ListDrawValue(const Value:string;ACanvas:TCanvas;const ARect:TRect;ASelected:Boolean);
  procedure ListMeasureWidth(const Value:string;ACanvas:TCanvas; var AWidth:Integer);
  procedure ListMeasureHeight(const Value:string;ACanvas:TCanvas; var AHeight:Integer);
  procedure PropDrawName(ACanvas: TCanvas; const ARect: TRect; ASelected: Boolean);
  procedure PropDrawValue(ACanvas: TCanvas; const ARect: TRect; ASelected: Boolean);
end;

Procedure Register;

implementation

procedure TBooleanPropertyImage.ListDrawValue(const Value: string;
  ACanvas: TCanvas; const ARect: TRect; ASelected: Boolean);
var
  Valor: Boolean;
  OldPenColor, OldBrushColor: TColor;
begin
  with ACanvas do
  try
    OldPenColor := Pen.Color;
    OldBrushColor := Brush.Color;
    FillRect(rect(ARect.Left,ARect.Top,14+ARect.Left,15+ARect.Top));
    Valor := Boolean(GetEnumValue(GetPropType, Value));
    if not Valor then
      begin
        Pen.Color := clBlack;
        Rectangle(ARect.Left+1,1+ARect.Top,14+ARect.Left,14+ARect.Top);
        Pen.Color := clRed;
        MoveTo(3+ARect.Left,7+ARect.Top);
        LineTo(3+ARect.Left,9+ARect.Top);
        LineTo(5+ARect.Left,11+ARect.Top);
        LineTo(11+ARect.Left,5+ARect.Top);
        LineTo(11+ARect.Left,3+ARect.Top);
        LineTo(5+ARect.Left,9+ARect.Top);
        LineTo(3+ARect.Left,7+ARect.Top);
        MoveTo(3+ARect.Left,8+ARect.Top);
        LineTo(5+ARect.Left,10+ARect.Top);
        LineTo(11+ARect.Left,4+ARect.Top);
      end
    else
      begin
        Pen.Color := clBlack;
        Rectangle(ARect.Left+1,1+ARect.Top,14+ARect.Left,14+ARect.Top);
        Pen.Color := $0000BF00;
        MoveTo(3+ARect.Left,7+ARect.Top);
        LineTo(3+ARect.Left,9+ARect.Top);
        LineTo(5+ARect.Left,11+ARect.Top);
        LineTo(11+ARect.Left,5+ARect.Top);
        LineTo(11+ARect.Left,3+ARect.Top);
        LineTo(5+ARect.Left,9+ARect.Top);
        LineTo(3+ARect.Left,7+ARect.Top);
        MoveTo(3+ARect.Left,8+ARect.Top);
        LineTo(5+ARect.Left,10+ARect.Top);
        LineTo(11+ARect.Left,4+ARect.Top);
      end;
  finally
    Brush.Color := OldBrushColor;
    Pen.Color := OldPenColor;
    DefaultPropertyListDrawValue(Value, ACanvas,Rect((ARect.Bottom-ARect.Top)+ARect.Left-1,ARect.Top,ARect.Right,
    ARect.Bottom),ASelected);
  end;
end;

procedure TBooleanPropertyImage.ListMeasureHeight(const Value: String;
  ACanvas: TCanvas; var AHeight: Integer);
begin
  AHeight := AHeight + 0;// zero pode ser trocado por uma constante
end;

procedure TBooleanPropertyImage.ListMeasureWidth(const Value: String;
  ACanvas: TCanvas; var AWidth: Integer);
begin
  AWidth := AWidth + ACanvas.TextHeight('Ag') + 2 + 0;// zero pode ser trocado por uma constante
end;

procedure TBooleanPropertyImage.PropDrawValue(ACanvas: TCanvas; const ARect: TRect;
  ASelected: Boolean);
begin
  if GetVisualValue <> '' then
    ListDrawValue(GetVisualValue,ACanvas,ARect,True)
  else
    DefaultPropertyDrawValue(Self,ACanvas,ARect);
end;

procedure TBooleanPropertyImage.PropDrawName(ACanvas: TCanvas; const ARect: TRect;
  ASelected: Boolean);
begin
  DefaultPropertyDrawName(Self,ACanvas,ARect);
end;

procedure register;
begin
  RegisterPropertyEditor(TypeInfo(Boolean),nil,'',TBooleanPropertyImage);
end;

end.




