unit Unit11;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ujson, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls;


type
  TWrapRecord = record

    Height: Integer;

    Lines: array of string;

  end;
type
  TForm11 = class(TForm)
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    lbTrend: TListBox;
    edtUsr: TEdit;
    edtPass: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lbAmigos: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure lbAmigosMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure lbAmigosDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);

  private
    { Private declarations }
  public
    json :  TJSONObject;
    upd: TJSONArray;
    response: string;
    { Public declarations }
  end;

var
  Form11: TForm11;

implementation

{$R *.dfm}

function WrapText(Canvas:TCanvas; Text:string;
  const MaxWidth:integer):TWrapRecord;
var
  S: string;
  CurrWidth:integer;
begin
  SetLength(Result.Lines,0);
  Result.Height := 0;
  CurrWidth := MaxWidth;
  Text := Text+' ';
  repeat
    S := copy(Text, 1, pos(' ',Text)-1);
    Delete(Text, 1, pos(' ',Text));
    if (Canvas.TextWidth(S+' ')+CurrWidth) <= MaxWidth then
     begin
       with Result do
         Lines[High(Lines)] := Lines[High(Lines)] + ' ' +S;
       Inc(CurrWidth, Canvas.TextWidth(S+' '));
     end
     else
       with Result do
       begin
         if length(Lines) > 0 then
           Inc(Height,Canvas.TextHeight(Lines[High(Lines)]));
         SetLength(Lines,length(Lines)+1);
         Lines[High(Lines)] := S;
       CurrWidth := Canvas.TextWidth(S);
     end;
   until length(TrimRight(Text)) = 0;
   with Result do
     Inc(Height,Canvas.TextHeight(Lines[High(Lines)]));
 end;

procedure TForm11.Button1Click(Sender: TObject);
var
  i,j: integer;
  tag: ansistring;
  text, user, line: ansistring;
begin

  idhttp1.Request.Username := ansitoutf8(edtUsr.text);
  idHTTP1.Request.Password := ansitoutf8(edtPass.Text);
  idHTTP1.Request.BasicAuthentication := true;
  
  response := IdHTTP1.get(ansitoutf8('http://twitter.com/statuses/friends_timeline.json'));
  upd := TJSONArray.create(response);

  for j := 0 to 9 do begin
    text := upd.getJSONObject(j).getString('text');
    user := 'Por @'+upd.getJSONObject(j).getJSONObject('user').getString('screen_name')+' - ';
    text := user + text;
    lbAmigos.Items.Add(text);
  end;

  upd.destroy;
  
  idhttp1.Disconnect;
  response := IdHTTP1.Get('http://search.twitter.com/trends.json');
  json := TJSONObject.create(response);

  for i := 0 to 9 do begin
    tag := UTF8Decode(json.getJSONArray('trends').getJSONObject(i).getString('name'));
    lbTrend.Items.Add(tag);
  end;

  json.Destroy;
end;


procedure TForm11.lbAmigosDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);

var
  WrapRecord: TWrapRecord;
  i,y: integer;
begin
  with Control as TListBox do
  begin
    Canvas.Font.Assign(Font);
    Canvas.FillRect(Rect);
    WrapRecord := WrapText(Canvas,Items[Index],ClientWidth);
    Y := Rect.Top;
    for i := Low(WrapRecord.Lines) to High(WrapRecord.Lines) do
    begin
      Canvas.TextOut(Rect.Left, y, WrapRecord.Lines[i]);
      Inc(y, Canvas.TextHeight(WrapRecord.Lines[i]));
     end;
    end;
end;


procedure TForm11.lbAmigosMeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
var
  WrapRecord:TWrapRecord;
begin
  with Control as TListBox do
  begin
    Canvas.Font.Assign(Font);
    WrapRecord := WrapText(Canvas,Items[Index],ClientWidth);
    if WrapRecord.Height < ItemHeight then
      WrapRecord.Height := ItemHeight;
  end;
  Height := WrapRecord.Height;
end;

end.
