unit uFuncoesLog;

interface

uses DBClient, Classes;

  //veja os comentrios no incio de cada funo
  function  StrToClientDataSet(StrDataSet: AnsiString): TStringStream; overload;
  procedure StrToClientDataSet(StrDataSet: AnsiString;
                               var CDS: TCustomClientDataSet); overload;
  function  ClientDataSetToStr(CDS: TCustomClientDataSet): AnsiString;
  function  CloneClientDataSet(CDS: TCustomClientDataSet): TCustomClientDataSet;

implementation

//------------------------------------------------------------------------------
//Retorna um StringStream, contendo a String que ser o Stream de um CDS
function StrToClientDataSet(StrDataSet: AnsiString): TStringStream; overload;
begin
  Result := TStringStream.Create(StrDataSet);
end;

//------------------------------------------------------------------------------
//Carrega em um CDS um StringStream, fazendo a converso Texto -> CDS
procedure StrToClientDataSet(StrDataSet: AnsiString;
                             var CDS: TCustomClientDataSet); overload;
begin
  //executa o LoadFromStrem no CDS passado por parmetro
  CDS.LoadFromStream(TStringStream.Create(StrDataSet));
end;

//------------------------------------------------------------------------------
//Retorna um CDS em forma de String, fazendo a converso CDS -> Texto
function ClientDataSetToStr(CDS: TCustomClientDataSet): AnsiString;
var
  ResultStream: TStringStream;
begin
  //cria um ClientDataSet temporrio
  with TClientDataSet.Create(nil) do
  begin
    //associa o contedo do param. CDS ao CDS temp.
    Data         := CDS.Data;
    //cria um StringStream temporrio, vazio
    ResultStream := TStringStream.Create('');
    //Salva na StringStream o contedo do CDS temp.,
    //usando o formato XML
    SaveToStream(ResultStream, dfXML);
    //retorna  funo o contedo da StringStream
    Result       := ResultStream.DataString;
  end;
end;

//------------------------------------------------------------------------------
//Retorna o Clone de um ClientDataSet (no necessria para o Log em si)
function CloneClientDataSet(CDS: TCustomClientDataSet): TCustomClientDataSet;
begin
  //Cria um CDS para retornar  funo
  Result := TClientDataSet.Create(nil);
  //carrega ao CDS criado o contedo do CDS passado por parmetro
  Result.LoadFromStream(TStringStream.Create(ClientDataSetToStr(CDS)));
end;

end.
