unit uVisualizaLogs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls, Grids, DBGrids, DB, DBCtrls;

type
  TfrmVisualizaLogs = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    dtp1: TDateTimePicker;
    Label2: TLabel;
    dtp2: TDateTimePicker;
    btPesquisa: TBitBtn;
    PanelBotoes: TPanel;
    btVisualizar: TBitBtn;
    btSair: TBitBtn;
    btTransferir: TBitBtn;
    DBNavigator: TDBNavigator;
    dsLogs: TDataSource;
    PanelDados: TPanel;
    DBGrid1: TDBGrid;
    procedure btSairClick(Sender: TObject);
    procedure btPesquisaClick(Sender: TObject);
    procedure DBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btVisualizarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    aSQL: String;
  public
    { Public declarations }
  end;

var
  frmVisualizaLogs: TfrmVisualizaLogs;

implementation

uses uDM, uLib, uVisualizaDetalhesLog;

{$R *.dfm}

procedure TfrmVisualizaLogs.btPesquisaClick(Sender: TObject);
begin
  dm.cdsLogs.Close;
  dm.qryLogs.SQL.Text := 'SELECT * FROM LOGS WHERE DATA BETWEEN ' +
                      QuotedStr(FormatDateTime('MM/DD/YYYY', dtp1.Date)) +
                      ' AND ' +
                      QuotedStr(FormatDateTime('MM/DD/YYYY', dtp2.Date));
  dm.cdsLogs.Open;
end;

procedure TfrmVisualizaLogs.btSairClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmVisualizaLogs.btVisualizarClick(Sender: TObject);
begin
  AbreForm(TfrmVisualizaDetalhesLog, frmVisualizaDetalhesLog);
end;

procedure TfrmVisualizaLogs.DBGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_return  then
    btVisualizar.Click;
end;

procedure TfrmVisualizaLogs.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  dm.qryLogs.SQL.Text := aSQL;
end;

procedure TfrmVisualizaLogs.FormCreate(Sender: TObject);
begin
  dtp1.Date := Date;
  dtp2.Date := Date;
  aSQL := dm.qryLogs.SQL.Text;
end;

procedure TfrmVisualizaLogs.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    btSair.Click;
end;

end.
